<script>
  import { terminal_content, loading } from './scripts/stores'
  import { createEventDispatcher } from "svelte"

  // define return Strings from FrontEnd-Commands 
  const DEFAULT_CONSOLE_INFO = `Welcome User for a list of all commands write :help. \n`
  const DEFAULT_TITLE = "Terminal"
  const PREFIX_SYMBOL_DOLLAR = "$"
  const ABOUT_INFO = `This is a console support for OpenTable, type :help for some hints`
  const HELP_INFO = 
  `HELP INFO
  Following are terminal-only-commands:
  :help help
  :about about this console
  :clear to clear the console
  For natural language use < as extra prefix before typing.
  Or just type in a command.`

  // other constants
  export let title
  export let fontsize
  export let fontfamily
  
  let prefix_symbol
  let prefix_symbol_natural_language = "<" // prefix symbol for SPC
  let show_terminal = true
  let minimize_terminal = true
  let max_style = ""
  let font_style = ""
  let input_value = ""

  let terminal_input_dispatcher = createEventDispatcher()

  onLoad()

  function onLoad(){
    if(!title) title = DEFAULT_TITLE
    if(!prefix_symbol) prefix_symbol = PREFIX_SYMBOL_DOLLAR
    if(fontsize) font_style += `font-size:${fontsize};`
    if(fontfamily) font_style += `font-family:${fontfamily};`
  }

  function onTerminalClear(){
    terminal_content.set(DEFAULT_CONSOLE_INFO)
    clearInputString();
  }

  function clearInputString(){
    input_value = ""
  }

  function onCommandConfirm(d){
    if(d.key === "Enter"){
      processCommands(input_value);
      clearInputString();
    }
  }

  function onMinimizeWin(){
    minimize_terminal = !minimize_terminal 
  }

  function addTerminalLine(lineToAdd) {
    terminal_content.update(n => n + prefix_symbol + input_value)
    terminal_content.update(n => n + lineToAdd + "\n")
  }

  function dispatchTerminalInput(input) {
    terminal_input_dispatcher("terminalinputentered", {
      terminal_input: input
    })
  }

  function processCommands(input){
    let str = input.trim();
    switch (str) {
      case ":help":
      case "help":
        addTerminalLine(HELP_INFO);
        break;
      case ":clear":
      case "clear":
        onTerminalClear();
        break;
      case ":about":
      case "about":
        addTerminalLine(ABOUT_INFO);
        break;
      default:
        terminal_content.update(n => n + prefix_symbol + input_value)
        dispatchTerminalInput(str)
        loading.update(() => "true")
    }
  }  
</script>

  
{#if show_terminal}
  <div class="terminal" style="{font_style}{max_style}">
    <div class="terminal-header">
      <span class="bullet bullet-minimize" on:click={onMinimizeWin}></span>
      <span class="title" on:click={onMinimizeWin}>{title}</span>
    </div>
    {#if minimize_terminal === false}
      <div class="terminal-window">
        <pre>
          {$terminal_content}
        </pre>
        <div class="terminal-prompt" >
            <!-- svelte-ignore a11y-autofocus -->
            <textarea class="terminal-input" rows="2" on:keyup={onCommandConfirm} bind:value={input_value} autofocus></textarea>
        </div>
      </div>
    {/if}
  </div>
{/if}
  
